"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileSystem = void 0;
const fs_1 = __importDefault(require("fs"));
class FileSystem {
    constructor(name, path) {
        this.name = name;
        this.path = path;
    }
    read() {
        return __awaiter(this, void 0, void 0, function* () {
            let content = "";
            yield fs_1.default.readFile(this.path + "/" + this.name, "utf8", (err, data) => {
                if (err)
                    throw err;
                content = data;
                console.log("Read to " + this.name + " successfully");
            });
            return content;
        });
    }
    write(data) {
        return __awaiter(this, void 0, void 0, function* () {
            fs_1.default.writeFile(this.path + "/" + this.name, data, (err) => {
                if (err)
                    throw err;
                console.log("Wrote to " + this.name + " successfully");
            });
        });
    }
}
exports.FileSystem = FileSystem;
