"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _FileSystemService_fullPath;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileSystemService = void 0;
const fs_1 = __importDefault(require("fs"));
class FileSystemService {
    constructor(name, path) {
        _FileSystemService_fullPath.set(this, void 0);
        this.name = name;
        this.path = path;
        __classPrivateFieldSet(this, _FileSystemService_fullPath, this.path + "/" + this.name, "f");
    }
    read() {
        return __awaiter(this, void 0, void 0, function* () {
            let content = "";
            yield fs_1.default.readFile(__classPrivateFieldGet(this, _FileSystemService_fullPath, "f"), "utf8", (err, data) => {
                if (err)
                    throw err;
                content = data;
                // console.log("Read to " + this.name + " successfully");
            });
            return content;
        });
    }
    write(data) {
        return __awaiter(this, void 0, void 0, function* () {
            fs_1.default.writeFile(__classPrivateFieldGet(this, _FileSystemService_fullPath, "f"), data, (err) => {
                if (err)
                    throw err;
                // console.log("Wrote to " + this.name + " successfully");
            });
        });
    }
    getFullPath() {
        return __classPrivateFieldGet(this, _FileSystemService_fullPath, "f");
    }
}
exports.FileSystemService = FileSystemService;
_FileSystemService_fullPath = new WeakMap();
