"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileSystemService = exports.Csv = exports.ParserFactory = void 0;
const Csv_1 = require("../models/Csv");
Object.defineProperty(exports, "Csv", { enumerable: true, get: function () { return Csv_1.Csv; } });
const ParserFactory_1 = require("../providers/factories/ParserFactory");
Object.defineProperty(exports, "ParserFactory", { enumerable: true, get: function () { return ParserFactory_1.ParserFactory; } });
const FileSystemService_1 = require("../providers/services/FileSystemService");
Object.defineProperty(exports, "FileSystemService", { enumerable: true, get: function () { return FileSystemService_1.FileSystemService; } });
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const jsonFile = {
            "1": { person: { name: "fuad", id: "1443" }, price: 123 },
            "2": { person: { name: "test", id: "51542" } },
        };
        console.log(jsonFile);
        const parserFactory = new ParserFactory_1.ParserFactory();
        const options = {
            hasId: true,
            single: false,
            setDefaultValues: true,
        };
        const jsonParser = parserFactory.make("jsonParser", jsonFile, options);
        const csv = jsonParser.parse(["person.id", "person.name", "price"]);
        const csvData = csv.make();
        console.log(csvData);
        const fileSystemService = new FileSystemService_1.FileSystemService("data.csv", "./Data");
        yield fileSystemService.write(csvData);
        const csvParser = parserFactory.make("csvParser", csv);
        const json = csvParser.parse();
        console.log(json);
        const newJsonParser = parserFactory.make("jsonParser", json, options);
        const newCsv = newJsonParser.parse([
            "person.id",
            "person.name",
            "price",
        ]);
        console.log(newCsv.make());
    });
}
main().then(() => {
    console.log("done");
});
